#!/usr/bin/env python
from os import *

data_size = {'a9a':26049, 'real-sim':57848, 'news20.binary':15997, 'rcv1_test.binary':541920, 'train308.scale':140963, 'leisure.scale':368444, 'astro':49896}
data_list = ['a9a', 'real-sim', 'news20.binary','rcv1_test.binary']
eps = 1e-2  
perfeps = 0.05
pegasos_pass = 500
#One can use a stricter stopping condition to obtain a more accurate solution

def compare(data):

	#cddual_l1 (without shrinking)
	cmd ='./liblinear/train -s 4 -c 1 -e %s data/%s.train data/%s.test > log/DCDL1_%s'\
			%(eps, data, data, data)
	print cmd 
	system(cmd)

	#pegasos
	iter = pegasos_pass * data_size[data] 
	cmd ='./pegasos/pegasos -testFile data/%s.test -lambda %.10f -iter %s data/%s.train > log/PEGASOS_%s'\
			%( data, 1.0/data_size[data],iter, data, data)
	print cmd
	system(cmd)

	#svmperf
	cmd = './svmperf/svm_perf_learn --b 0 -c %lf -e %lf -T data/%s.test data/%s.train model > tmp'\
			%( float(data_size[data])*0.01, perfeps, data, data )
	print cmd
	system(cmd)
	
	cmd = 'python parse_perf.py tmp > log/SVMPERF_%s'%data
	print cmd
	system(cmd)

for data in data_list:
		compare(data)
